=== debian/changelog ===
checkit-tiff (0.2.3-2) unstable; urgency=medium

  * Team upload.
  * Add missing copyright
    Closes: #854769
  * Standards-Version: 4.1.3
  * debhelper 11

 -- Andreas Tille <tille@debian.org>  Tue, 20 Feb 2018 21:00:43 +0100

checkit-tiff (0.2.3-1) unstable; urgency=medium

  * Initial release
    Closes: #830293

 -- Andreas Romeyke <art1@andreas-romeyke.de>  Sun, 05 Feb 2017 21:20:37 +0100
