=== debian/control ===
Source: checkit-tiff
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Andreas Romeyke <art1@andreas-romeyke.de>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               cmake,
               libpcre3-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/checkit-tiff.git
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/checkit-tiff.git
Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff

Package: checkit-tiff
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: conformance checker for baseline TIFFs
 "checkit_tiff" is a conformance checker for baseline TIFFs (with various
 extensions). It works in different way than other tools. Instead to use
 a hardcoded rule set with predefined values, you are able to define tags
 and corresponding values more fine granulary. The rulesets are human
 readable and could be adapted to own needs.
 .
 The "checkit_tiff" works on commandline and therefore it is embedable
 in scripts
 .
 The tools are developed for purposes of curation and longterm
 preservation
