=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --sourcedirectory=src --buildsystem=cmake

override_dh_install:
	dh_install
	find debian -name "LICENSE" -delete
