=== debian/watch ===
version=3

https://github.com/SLUB-digitalpreservation/checkit_tiff/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
