## checkit-tiff 0.4.2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,14 +8,19 @@
 file( GLOB checkit_tiff_SOURCES 
   "${PROJECT_SOURCE_DIR}/tagrules/*.c"
   "${PROJECT_SOURCE_DIR}/ifdrules/*.c"
+  "${PROJECT_SOURCE_DIR}/messages/*.c"
   "${PROJECT_SOURCE_DIR}/helper/*.c"
+  "${PROJECT_SOURCE_DIR}/helper/renderer/*.c"
   "${PROJECT_SOURCE_DIR}/parser/*parser.c"
   "${PROJECT_SOURCE_DIR}/validate_icc/*.c"
   "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
   )
 
 file( GLOB checkit_tiff_risk_SOURCES
-  "${PROJECT_SOURCE_DIR}/helper/*.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_helper.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_print.c"
+  "${PROJECT_SOURCE_DIR}/helper/check_tiffparse.c"
+  "${PROJECT_SOURCE_DIR}/messages/*.c"
   "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
 )
 
@@ -24,11 +29,22 @@
 #
 execute_process( COMMAND git rev-list HEAD --count OUTPUT_VARIABLE REPO_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE )
 execute_process( COMMAND git rev-parse --abbrev-ref HEAD OUTPUT_VARIABLE BUILD_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE)
+execute_process( COMMAND git describe --tags OUTPUT_VARIABLE BUILD_TAG OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process( COMMAND git rev-parse HEAD OUTPUT_VARIABLE BUILD_REV_ID OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process( COMMAND git describe --long --tags --dirty --always OUTPUT_VARIABLE BUILD_REV_ID_SHORT OUTPUT_STRIP_TRAILING_WHITESPACE)
-add_definitions(-DVERSION="${BUILD_BRANCH}")
+add_definitions(-DVERSION="${BUILD_BRANCH}_${BUILD_TAG}")
 add_definitions(-DREPO_REVISION="${REPO_REVISION}")
-add_definitions(-std=gnu11)
+
+# Check for compatibility with gnu11
+# Compile with gnu11 support.
+include(CheckCCompilerFlag)
+CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_GNU11)
+if(COMPILER_SUPPORTS_GNU11)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
+else()
+    message(STATUS "Your compiler (${CMAKE_C_COMPILER}) has no gnu11 support. If you are using clang on Apple OS X, please switch to gcc (version > 4.7) which is compliant with the C11 standard.")
+endif()
+
 if(WIN32)
   add_definitions(-D__WIN32__=1)
   SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
