=== debian/changelog ===
checkit-tiff (0.4.2-1) unstable; urgency=medium

  * Team upload.
  * Fix Vcs fields
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * No tab in license text (routine-update)
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 26 Aug 2021 10:45:55 +0200
