=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Uploaders: Andreas Romeyke <art1@andreas-romeyke.de>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libpcre3-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/checkit-tiff.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/checkit-tiff.git
+Standards-Version: 4.6.0
+Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
+Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
 Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff
+Rules-Requires-Root: no
 
 Package: checkit-tiff
 Architecture: any
