=== debian/watch ===
version=4

https://github.com/SLUB-digitalpreservation/checkit_tiff/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
