=== debian/changelog ===
checkit-tiff (1.4.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.4.4 (Closes: #1050516).

 -- Bastian Germann <bage@debian.org>  Sun, 27 Aug 2023 23:57:43 +0200

checkit-tiff (1.4.3-2) unstable; urgency=medium

  * Team upload.
  * Add missing B-D pkg-config.
  * Fix version string for builds without git.

 -- Bastian Germann <bage@debian.org>  Thu, 24 Aug 2023 15:59:53 +0000

checkit-tiff (1.4.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.4.3.
  * Switch to new upstream repository (Closes: #969162).
  * Update build dependencies (Closes: #1000120).
  * Build in directory "build" as expected by upstream test code.
  * Enforce non-parallel build preventing interference between tests.
  * Disable fortify from hardening feature area due to failing test.
  * Add patch fixing version string for builds outside upstream repository.
  * Bump Standards-Version to 4.6.2.
  * Drop reference to non-existing file from debian/copyright.
  * Add lintian-overrides for grammar.xhtml.

 -- Elias Oltmanns <oltmanns@zib.de>  Wed, 12 Jul 2023 09:56:22 +0200
