=== debian/control ===
--- 
+++ 
@@ -5,11 +5,17 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libpcre3-dev
-Standards-Version: 4.6.0
+               dh-cmake,
+               dh-cmake-compat (= 1),
+               pkg-config,
+               libpcre2-dev,
+               libdata-printer-perl,
+               libfile-slurp-perl,
+               libtest-base-perl
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
-Homepage: https://github.com/SLUB-digitalpreservation/checkit_tiff
+Homepage: https://git.fsfe.org/art1pirat/checkit_tiff
 Rules-Requires-Root: no
 
 Package: checkit-tiff
