=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-fortify

%:
	dh $@ --sourcedirectory=src --builddirectory=build \
		--no-parallel --buildsystem=cmake

override_dh_install:
	dh_install
	find debian -name "LICENSE" -delete
