## checkit-tiff 1.6.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.9.4)
+cmake_minimum_required (VERSION 3.14)
 project (checkit_tiff)
 include_directories("${PROJECT_SOURCE_DIR}/headers")
 include_directories("${PROJECT_SOURCE_DIR}/lib/include")
@@ -7,6 +7,7 @@
 include(CheckFunctionExists)
 include(CheckIPOSupported)
 include(CheckCCompilerFlag)
+include(CheckPIESupported)
 
 file( GLOB checkit_tiff_SOURCES
   "${PROJECT_SOURCE_DIR}/tagrules/*.c"
@@ -40,18 +41,28 @@
 add_definitions(-D_GNU_SOURCE)
 
 check_ipo_supported(RESULT LTO_IS_SUPPORTED OUTPUT LTO_CHECK_ERROR)
-if (LTO_IS_SUPPORTED)
+if (LTO_IS_SUPPORTED AND NOT CMAKE_C_CLANG_TIDY)
   message(STATUS "IPO / LTO enabled")
   set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
 else()
-  message(STATUS "IPO / LTO unsupported: <${LTO_CHECK_ERROR}>")
+  if (CMAKE_C_CLANG_TIDY)
+    set (LTO_CHECK_ERROR "clang-tidy does not support interprocedural optimization!")
+  endif()
+  message(STATUS "IPO / LTO unsupported: ${LTO_CHECK_ERROR}")
+endif()
+
+check_pie_supported(OUTPUT_VARIABLE output LANGUAGES C)
+if(NOT CMAKE_C_LINK_PIE_SUPPORTED)
+  message(WARNING "PIE is not supported at link time: ${output}.\n"
+          "PIE link options will not be passed to linker.")
+  set(CMAKE_POSITION_INDEPENDENT_CODE FALSE)
 endif()
 
 # add default CFLAGS
 if(CMAKE_COMPILER_IS_GNUCC)
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat -Werror=format-security -ffunction-sections -fdata-sections")
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+#set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
 endif()
 
 set(CMAKE_OPTIMIZE_DEPENDENCIES TRUE)
@@ -136,7 +147,8 @@
   set(CMAKE_CXX_LINK_EXECUTABLE "${CMAKE_C_LINK_EXECUTABLE} -lnodefs.js -lnoderawfs.js")
 else()
   message(STATUS "enabling relro PIE linker flags")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+  #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro,--gc-sections -fPIE")
+  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
 endif()
 
 if(STATIC)
@@ -259,9 +271,3 @@
 
 include(FindPerl)
 if (PERL_FOUND)
-  enable_testing()
-  set(T_DIR ${PROJECT_SOURCE_DIR}/../t )
-  add_executable(test_stack "../t/01_test_stack.c")
-  add_test(NAME 01_test_stack COMMAND test_stack WORKING_DIRECTORY ${T_DIR})
-  add_test(NAME 01_grammar      COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 01_test_grammar.t         WORKING_DIRECTORY  ${T_DIR} )
-  add_test(NAME 02_config       COMMAND ${PERL_EXECUTABLE} -I ${T_DIR} 02_test_config_examples.t WORKING_DIRECTORY  ${T_DIR} )
