=== src/lib/CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,7 @@
         "${PROJECT_SOURCE_DIR}/risk_analyzer/*.c"
         )
 
-
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
-
 
 if (RefIccMAX_FOUND)
     set(checkit_tiff_SOURCES "${checkit_tiff_SOURCES};${PROJECT_SOURCE_DIR}/validate_icc/validate_icc_with_IccProfLib.cpp")
