=== debian/changelog ===
checkit-tiff (1.6.0-2) unstable; urgency=medium

  * Team upload.
  * d/control: update Build-Depends: pkg-config => pkgconf
  * add d/p/fix-typo.patch

 -- xiao sheng wen <atzlinux@debian.org>  Mon, 25 Aug 2025 15:15:36 +0800

checkit-tiff (1.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.6.0
  * rm d/p/use-type-specialized-ct_readXX-functions.patch, new upstream applied
  * d/copyright: update year info to 2025
  * d/u/metadata: add Bug-Database URL
  * d/rules:
      - use execute_after_dh_install target
      - delete -fortify in export DEB_BUILD_MAINT_OPTIONS
      - remove --buildsystem=cmake in dh options
  * d/control: Bump Standards-Version: 4.7.2, no change need

 -- xiao sheng wen <atzlinux@debian.org>  Fri, 11 Apr 2025 12:05:25 +0800

checkit-tiff (1.4.4-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.

  [ Andreas Metzler ]
  * Team upload.
  * Fix FTBFS with gcc-14 by cherrypicking
    use-type-specialized-ct_readXX-functions.patch from upstream GIT master.
    Closes: #1074877

 -- Andreas Metzler <ametzler@debian.org>  Sat, 10 Aug 2024 11:52:06 +0200
