=== debian/control ===
--- 
+++ 
@@ -7,12 +7,12 @@
                cmake,
                dh-cmake,
                dh-cmake-compat (= 1),
-               pkg-config,
+               pkgconf,
                libpcre2-dev,
                libdata-printer-perl,
                libfile-slurp-perl,
                libtest-base-perl
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/checkit-tiff
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/checkit-tiff.git
 Homepage: https://git.fsfe.org/art1pirat/checkit_tiff
