=== debian/watch ===
version=4
opts="mode=git,filenamemangle=s%.*/v(@ANY_VERSION@)$%@PACKAGE@-$1%" \
    https://git.fsfe.org/art1pirat/checkit_tiff.git \
    ^refs/tags/v(\d+(?:\.\d+)*)$
